#!/bin/bash

#clean up
rm -r results
rm results*
rm -r tmpDir
mkdir tmpDir
rm tmp

echo -n "" > tmpDir/inconsistentNotung
echo -n "" > tmpDir/inconsistentRangerDTL

cycles=100

for leaves in 50
do
	for pco in 0.25 0.50 0.75
	do
		for psw in 0.25 0.50 0.75
		do
			echo -n "" > resultsCI1-$pco-$psw
			echo -n "" > resultsCI2-$pco-$psw
			echo -n "" > resultsJane-$pco-$psw
			echo -n "" > resultsTreemap-$pco-$psw
			echo -n "" > resultsNotung-$pco-$psw
			echo -n "" > resultsRanger-$pco-$psw
			for i in $(seq 1 $cycles);
			do
				echo -n "$i $pco-$psw: "
				simFile=simulations/$pco/$psw/simulation$i.reco
				parasites=$(head -n +2 $simFile | tail -n -1)
				
				echo -n "CoRe-ILP1 "
				recoFile=simulations/$pco/$psw/simulation$i.ci1.reco
				cat $recoFile | tail -n +6 > tmp
				echo "" >> tmp
				truepositives=0
				hits=0
				precision=0
				while read line
				do
				  hits=$(($hits+1))
				  foo=$(grep "$line" $simFile)
				  if [[ "$foo" ]]
				  then
					truepositives=$(echo "$truepositives+1" | bc)
				  fi
				done < tmp
				truepositives=$(echo "$truepositives-$parasites" | bc)
				hits=$(echo "$hits-$parasites" | bc)
				precision=$(echo "scale=5; $truepositives/$hits" | bc)
				if [[ -z "$precision" ]]; then precision="0"; fi
				time=$(cat "$recoFile" | tail -n +2 | head -n +1)
				if [[ -z "$time" ]]
				then 
					time="0"
					precision="0"
				fi
				#echo -e "$truepositives\t$hits\t$parasites"
				echo -e "$time\t$precision" >> resultsCI1-$pco-$psw
				
				echo -n "CoRe-ILP2 "
				recoFile=simulations/$pco/$psw/simulation$i.ci2.reco
				cat $recoFile | tail -n +6 > tmp
				echo "" >> tmp
				truepositives=0
				hits=0
				precision=0
				while read line
				do
				  hits=$(($hits+1))
				  foo=$(grep "$line" $simFile)
				  if [[ "$foo" ]]
				  then
					truepositives=$(echo "$truepositives+1" | bc)
				  fi
				done < tmp
				truepositives=$(echo "$truepositives-$parasites" | bc)
				hits=$(echo "$hits-$parasites" | bc)
				precision=$(echo "scale=5; $truepositives/$hits" | bc)
				if [[ -z "$precision" ]]; then precision="0"; fi
				time=$(cat "$recoFile" | tail -n +2 | head -n +1)
				if [[ -z "$time" ]]
				then 
					time="0"
					precision="0"
				fi
				#echo -e "$truepositives\t$hits\t$parasites"
				echo -e "$time\t$precision" >> resultsCI2-$pco-$psw
				
				echo -n "Jane "
				recoFile=simulations/$pco/$psw/simulation$i.jt.nex.j4.reco
				cat $recoFile | tail -n +6 > tmp
				truepositives=0
				hits=0
				precision=0
				while read line
				do
				  hits=$(($hits+1))
				  foo=$(grep "$line" $simFile)
				  if [[ "$foo" ]]
				  then
					truepositives=$(echo "$truepositives+1" | bc)
				  fi
				done < tmp
				truepositives=$(echo "$truepositives-$parasites" | bc)
				hits=$(echo "$hits-$parasites" | bc)
				precision=$(echo "scale=5; $truepositives/$hits" | bc)
				if [[ -z "$precision" ]]; then precision="0"; fi
				time=$(cat "$recoFile" | tail -n +2 | head -n +1)
				if [[ -z "$time" ]]
				then 
					time="0"
					precision="0"
				fi
				#echo -e "$truepositives\t$hits\t$parasites"
				echo -e "$time\t$precision" >> resultsJane-$pco-$psw
				
				echo -n "Treemap "
				recoFile=simulations/$pco/$psw/simulation$i.jt.nex.t3.reco
				cat $recoFile | tail -n +6 > tmp
				truepositives=0
				hits=0
				precision=0
				while read line
				do
				  hits=$(($hits+1))
				  foo=$(grep "$line" $simFile)
				  if [[ "$foo" ]]
				  then
					truepositives=$(echo "$truepositives+1" | bc)
				  fi
				done < tmp
				truepositives=$(echo "$truepositives-$parasites" | bc)
				hits=$(echo "$hits-$parasites" | bc)
				precision=$(echo "scale=5; $truepositives/$hits" | bc)
				if [[ -z "$precision" ]]; then precision="0"; fi
				time=$(cat "$recoFile" | tail -n +2 | head -n +1)
				if [[ -z "$time" ]]
				then 
					time="0"
					precision="0"
				fi
				#echo -e "$truepositives\t$hits\t$parasites"
				echo -e "$time\t$precision" >> resultsTreemap-$pco-$psw
				
				echo -n "Notung "
				recoFile=simulations/$pco/$psw/simulation$i.notung.genetree.reconciled.0.ntg
				java -jar NotungRangerDTLParser.jar $recoFile notung.reco notung
				cat notung.reco | tail -n +6 > tmp
				truepositives=0
				hits=0
				precision=0
				while read line
				do
				  hits=$(($hits+1))
				  foo=$(grep "$line" $simFile)
				  if [[ "$foo" ]]
				  then
					truepositives=$(echo "$truepositives+1" | bc)
				  fi
				done < tmp
				if [ "$hits" -ne 0 ]
				then
					precision=$(echo "scale=5; $truepositives/$hits" | bc)
				fi
				if [[ -z "$precision" ]]; then precision="0"; fi
				time=$(cat notung.reco | tail -n +2 | head -n +1)
				if [[ -z "$time" ]]
				then 
					time="0"
					precision="0"
				fi
				rm notung.reco
				#echo -e "$truepositives\t$hits\t$parasites"
				echo -e "$time\t$precision" >> resultsNotung-$pco-$psw
				
				echo "RangerDTL"
				recoFile=simulations/$pco/$psw/simulation$i.rangerdtl.reco
				java -jar NotungRangerDTLParser.jar $recoFile ranger.reco ranger
				cat ranger.reco | tail -n +6 > tmp
				truepositives=0
				hits=0
				precision=0
				while read line
				do
				  hits=$(($hits+1))
				  foo=$(grep "$line" $simFile)
				  if [[ "$foo" ]]
				  then
					truepositives=$(echo "$truepositives+1" | bc)
				  fi
				done < tmp
				precision=$(echo "scale=5; $truepositives/$hits" | bc)
				if [[ -z "$precision" ]]; then precision="0"; fi
				time=$(cat ranger.reco | tail -n +2 | head -n +1)
				if [[ -z "$time" ]]
				then 
					time="0"
					precision="0"
				fi
				rm ranger.reco
				#echo -e "$truepositives\t$hits\t$parasites"
				echo -e "$time\t$precision" >> resultsRanger-$pco-$psw
			done
			# compute number of inconsistent NOTUNG and RangerDTL Solutions
			iNotung=$(ls simulations/$pco/$psw/*.txt | wc -l)
			iNotung=$(echo "$cycles - $iNotung" | bc)
			echo "$pco-$psw: $iNotung" >> tmpDir/inconsistentNotung
			iRanger=0
			for i in $(seq 1 $cycles);
			do
				cRanger=$(java -jar RangerConsistencyCkeck.jar simulations/$pco/$psw/simulation$i.rangerdtl.reco)
				iRanger=$(echo "$iRanger + $cRanger" | bc) 
			done
			iRanger=$(echo "$cycles - $iRanger" | bc)
			echo "$pco-$psw: $iRanger" >> tmpDir/inconsistentRangerDTL
		done
	done
done

mv results* tmpDir
mv tmpDir results
rm tmp


